/* File: IMBD.java
 * Author: Wayne Snyder
 * Date: Aug 1, 2020
 * Purpose: This is the template for HW 5, Problem B.4, CS 112, Fall 2020
 */


import java.io.*;
import java.util.*;

public class IMDB { 
  
  
  private static void readInFile(String fileName, Index I) {  
    
    final int maxLength =1000;    
    
    try {
      
      Scanner sc = new Scanner(new File(fileName));
      
      // read data from text file into array of strings
      String[] M = new String[maxLength];
      
      int next; 
      for(next = 0; next < maxLength && sc.hasNextLine(); ++next)  {     
        M[next] = sc.nextLine();                 // read next line of file
      }
      
      // Now you have to split each line into token on the separator "; "  
      // (NOTE:  you must split on semicolon plus space character, not just semicolon)
      // and insert the entry into the Index; the first token is the key
      // and the remaining tokens are the cast. 
      
      // Just to test input, remove this!
      
      for(int i = 0; i < next; ++i) {
        System.out.println("["+(i+1)+"]  " + M[i] + "\n"); 
      }
      
      
    }
    catch(FileNotFoundException e) {
      System.out.println(e.getMessage()); 
    }
  }
  
 // unit tests
  
  
  public static void main (String[] args) { 
    
    Index I = new Index(); 
    readInFile("moviesTest.txt", I);
  /*  
    System.out.println("\n[1] Printing out keys... should be:\n");
    System.out.println("\t\tSleepless in Seattle\n"
                         +"\t\t\t\tShining, The\n"
                         +"\t\t\tShape of Things, The\n"
                         +"\tMarked for Death\n"
                         +"\t\t\tJersey Girl\n"
                         +"\t\tCrocodile Dundee II\n"
                         +"\t\t\tConformista, Il\n"
                         +"Austin Powers in Goldmember\n"
                         +"\t\t101 Dalmatians\n"
                         +"\t100 Girls\n");
    I.printTreeKeys();
    
    System.out.println("\n[2] Testing size... should be:\n10");
    System.out.println(I.size()); 
    
    System.out.println("\n[3] Testing height... should be:\n4");
    System.out.println(I.height());
    
    System.out.println("\n[4] Testing getValues... should be:\nnull");
    
    System.out.println(I.getValues("Enter The Dragon"));
    
    System.out.println("\n[5] Testing getValues... should be:\n[Michael, Terence;McNet, Mike;Courtney, Dustin;Green, Donald;Ross, Bradley K.;Payne, Allen;Nagel, Seth;Madalone, Dennis;Davila, Edward;Green, Johnny;Szmanda, Eric;Bleiberg, Ehud;Bustard, Chris;Howard, Walker;Tucker, Jonathan;DeBello, James;OHara, John;Corpas, Londonn;Mars, Felicity;Steger, Julieanne]");
    System.out.println(); 
    System.out.println(I.getValues("100 Girls"));
    
    // Now build an inverted index
    System.out.println("\nBuilding inverted index....");
    Index InvI = I.getInvertedIndex();
    
    System.out.println("\n[6] Testing size... should be:\n435");
    System.out.println(InvI.size()); 
    
    System.out.println("\n[7] Testing height... should be:\n18");
    System.out.println(InvI.height());
    
    System.out.println("\n[8] Testing getValues... should be:\n[Austin Powers in Goldmember;Marked for Death]");
    
    System.out.println(InvI.getValues("DeVito, Danny"));
    
 
    */  
  }

   
}

